"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Aggregate = void 0;
const core_1 = require("@my-devkit/core");
const context_1 = require("./context");
class Aggregate {
    constructor() {
        this.id = null;
        this._type = null;
        this._events = [];
        this.id = (0, core_1.guid)();
        this._type = this.constructor.name;
    }
    get _path() {
        return `/aggregates/${this.id}`;
    }
    get hash() {
        return JSON.stringify((0, core_1.serialize)(this));
    }
    assert(value, errorMessage) {
        if (!value) {
            throw new core_1.DomainError(errorMessage);
        }
    }
    apply(event) {
        const methodName = `apply${event._type}`;
        if (!(methodName in this)) {
            throw new Error(`${this._type}.${methodName} method is missing!`);
        }
        event._aggregateId = this.id;
        event._aggregateType = this._type;
        event._correlationId = context_1.Context.correlationId;
        event._publishedBy = context_1.Context.user ? context_1.Context.user.uid : null;
        event.publishedAt = new Date();
        this[methodName](event);
        this._events.push(event);
    }
    get events() {
        return [...this._events];
    }
    clearEvents() {
        this._events = [];
    }
}
exports.Aggregate = Aggregate;
__decorate([
    (0, core_1.autoserializeAs)(String),
    __metadata("design:type", String)
], Aggregate.prototype, "id", void 0);
__decorate([
    (0, core_1.autoserializeAs)(String),
    __metadata("design:type", String)
], Aggregate.prototype, "_type", void 0);
//# sourceMappingURL=aggregate.js.map