import { Command, Event } from '@my-devkit/core';
import { ExecutionMode } from './execution-mode-enum';
export declare class Bus {
    private commandHandlers;
    private eventHandlers;
    send<T, C extends Command>(command: C): Promise<T>;
    publish<E extends Event>(event: E, mode?: ExecutionMode): Promise<void>;
    onCommand<C extends Command, R>(commandType: new () => C, handler: Bus.Handler<C, R>): void;
    onEvent<E extends Event>(eventType: new () => E, handler: Bus.Handler<E, void>, mode: ExecutionMode): void;
    onEachEvent<E extends Event>(handler: Bus.Handler<E, void>, mode: ExecutionMode): void;
    private getDictionaryKey;
    private registerEventHandler;
    private getEventHandlers;
}
export declare namespace Bus {
    type Handler<T, R> = (arg: T) => Promise<R>;
}
