import { Bus } from './bus';
import { ITransactionalClient, Type } from './interfaces';
interface UserRecord {
    uid: string;
    email?: string;
    displayName?: string;
    photoURL?: string;
    disabled: boolean;
}
export declare class Context {
    private static store;
    private static asyncHook;
    static init(): void;
    static create(bus: Bus): void;
    static resolve<T>(type: Type<T>): T;
    static getTransactionalClients(): ITransactionalClient[];
    static get bus(): Bus;
    static set correlationId(correlationId: string);
    static get correlationId(): string;
    static set eventId(eventId: string);
    static get eventId(): string;
    static set user(user: UserRecord);
    static get user(): UserRecord;
    static destroy(): void;
    static size(): number;
    static logRemainingKeys(): void;
    static commit(): Promise<void>;
}
export {};
