"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Body = Body;
const core_1 = require("@my-devkit/core");
const reflect_1 = require("../../reflect");
function Body() {
    return (target, propertyKey, parameterIndex) => {
        const methodArguments = (0, reflect_1.reflect)(target, propertyKey).getParameters();
        if (!methodArguments.hasOwnProperty(parameterIndex)) {
            throw new Error(`Body: can't find argument ${parameterIndex} on ${target.constructor.name}.${propertyKey.toString()}`);
        }
        const injector = (req) => (0, core_1.deserialize)(req.body, methodArguments[parameterIndex]);
        (0, reflect_1.reflect)(target, propertyKey).registerControllerRouteArgumentInjector(injector, parameterIndex);
    };
}
//# sourceMappingURL=body.js.map