"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@my-devkit/core");
const chai_1 = require("chai");
const reflect_1 = require("../../reflect");
const body_1 = require("./body");
const controller_1 = require("./controller");
describe('Given a Body decorator', () => {
    class Command {
        constructor() {
            this.testString = null;
            this.testDate = null;
        }
    }
    __decorate([
        (0, core_1.autoserializeAs)(String),
        __metadata("design:type", String)
    ], Command.prototype, "testString", void 0);
    __decorate([
        (0, core_1.autoserializeAs)(Date),
        __metadata("design:type", Date)
    ], Command.prototype, "testDate", void 0);
    let TestClass = class TestClass {
        testDate(param1) {
            return `testDate: ${param1}`;
        }
        testCommand(param1) {
            return `testCommand: ${param1}`;
        }
    };
    __decorate([
        __param(0, (0, body_1.Body)()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Date]),
        __metadata("design:returntype", String)
    ], TestClass.prototype, "testDate", null);
    __decorate([
        __param(0, (0, body_1.Body)()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Command]),
        __metadata("design:returntype", String)
    ], TestClass.prototype, "testCommand", null);
    TestClass = __decorate([
        (0, controller_1.Controller)('test')
    ], TestClass);
    describe('When decorator is called', () => {
        it('Then we should retrieve information via reflect', () => __awaiter(void 0, void 0, void 0, function* () {
            const config = (0, reflect_1.reflect)(TestClass).getControllerConfiguration();
            (0, chai_1.expect)(config.routes.length).equal(2, 'Wrong route count detected');
            const request1 = { body: '2021-02-08T11:14:23.318Z' };
            (0, chai_1.expect)(config.routes[0].argumentInjectors.length).equal(1, 'Wrong argumentInjectors length');
            (0, chai_1.expect)(config.routes[0].argumentInjectors[0](request1)).to.be.a('Date');
            (0, chai_1.expect)(config.routes[0].argumentInjectors[0](request1).toISOString()).equals((new Date('2021-02-08T11:14:23.318Z')).toISOString());
            const request2 = { body: { testString: 'test' } };
            const expectedBody2 = new Command();
            expectedBody2.testString = 'test';
            expectedBody2.testDate = null;
            (0, chai_1.expect)(config.routes[1].argumentInjectors.length).equal(1, 'Wrong argumentInjectors length');
            (0, chai_1.expect)(config.routes[1].argumentInjectors[0](request2)).to.be.instanceOf(Command);
            (0, chai_1.expect)(config.routes[1].argumentInjectors[0](request2)).deep.equal(expectedBody2);
        }));
    });
});
//# sourceMappingURL=body.spec.js.map