"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Param = Param;
const core_1 = require("@my-devkit/core");
const reflect_1 = require("../../reflect");
function Param(key) {
    return (target, propertyKey, parameterIndex) => {
        const methodArguments = (0, reflect_1.reflect)(target, propertyKey).getParameters();
        if (!methodArguments.hasOwnProperty(parameterIndex)) {
            throw new Error(`Param: can't find argument ${parameterIndex} on ${target.constructor.name}.${propertyKey.toString()}`);
        }
        const injector = (req) => {
            if (req.params.hasOwnProperty(key)) {
                return (0, core_1.deserialize)(req.params[key], methodArguments[parameterIndex]);
            }
        };
        (0, reflect_1.reflect)(target, propertyKey).registerControllerRouteArgumentInjector(injector, parameterIndex);
    };
}
//# sourceMappingURL=param.js.map