"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const reflect_1 = require("../../reflect");
const controller_1 = require("./controller");
const get_1 = require("./get");
const param_1 = require("./param");
describe('Given a Param decorator', () => {
    let Gender;
    (function (Gender) {
        Gender[Gender["Male"] = 0] = "Male";
        Gender["Female"] = "Female";
    })(Gender || (Gender = {}));
    let TestClass = class TestClass {
        getById(id) {
            return `getById: ${id}`;
        }
        getByGenderOlderThan(minDate, gender) {
            return `getByGenderOlderThan: ${gender} ${minDate.toISOString()}`;
        }
    };
    __decorate([
        (0, get_1.Get)(':id'),
        __param(0, (0, param_1.Param)('id')),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [String]),
        __metadata("design:returntype", String)
    ], TestClass.prototype, "getById", null);
    __decorate([
        (0, get_1.Get)(':gender/:minDate'),
        __param(0, (0, param_1.Param)('minDate')),
        __param(1, (0, param_1.Param)('gender')),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Date, Object]),
        __metadata("design:returntype", String)
    ], TestClass.prototype, "getByGenderOlderThan", null);
    TestClass = __decorate([
        (0, controller_1.Controller)('test')
    ], TestClass);
    describe('When decorator is called', () => {
        it('Then we should retrieve information via reflect', () => __awaiter(void 0, void 0, void 0, function* () {
            const config = (0, reflect_1.reflect)(TestClass).getControllerConfiguration();
            (0, chai_1.expect)(config.routes.length).equal(2, 'Wrong route count detected');
            const request1 = { params: { id: 'guid 1' } };
            (0, chai_1.expect)(config.routes[0].argumentInjectors.length).equal(1, 'Wrong argumentInjectors length for getById');
            (0, chai_1.expect)(config.routes[0].argumentInjectors[0](request1)).to.be.a('string');
            (0, chai_1.expect)(config.routes[0].argumentInjectors[0](request1)).equals('guid 1');
            const request2 = { params: { gender: 0, minDate: '2021-02-15T14:23:00.318Z' } };
            (0, chai_1.expect)(config.routes[1].argumentInjectors.length).equal(2, 'Wrong argumentInjectors length for getByGenderOlderThan');
            (0, chai_1.expect)(config.routes[1].argumentInjectors[0](request2)).to.be.a('Date');
            (0, chai_1.expect)(config.routes[1].argumentInjectors[0](request2).toISOString()).equals((new Date('2021-02-15T14:23:00.318Z')).toISOString());
            (0, chai_1.expect)(config.routes[1].argumentInjectors[1](request2)).equals(Gender.Male);
            request2.params.gender = 'Female';
            (0, chai_1.expect)(config.routes[1].argumentInjectors[1](request2)).equals(Gender.Female);
        }));
    });
});
//# sourceMappingURL=param.spec.js.map