"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommandHandler = CommandHandler;
const core_1 = require("@my-devkit/core");
const reflect_1 = require("../../reflect");
function CommandHandler() {
    return (target, propertyKey) => {
        const paramTypes = (0, reflect_1.reflect)(target, propertyKey).getParameters();
        if (paramTypes.length === 0) {
            throw new Error(`${target.constructor.name}.${propertyKey.toString()} should have one argument!`);
        }
        if (paramTypes.length > 1) {
            throw new Error(`${target.constructor.name}.${propertyKey.toString()} should have only one argument!`);
        }
        if (!(paramTypes[0].prototype instanceof core_1.Command)) {
            throw new Error(`${target.constructor.name}.${propertyKey.toString()} should have a command as argument!`);
        }
        (0, reflect_1.reflect)(target, propertyKey).registerCommandHandler(paramTypes[0].prototype);
    };
}
//# sourceMappingURL=command-handler.js.map