"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventHandler = EventHandler;
const core_1 = require("@my-devkit/core");
const reflect_1 = require("../../reflect");
function EventHandler(mode) {
    return (target, propertyKey) => {
        const paramTypes = (0, reflect_1.reflect)(target, propertyKey).getParameters();
        if (paramTypes.length === 0) {
            throw new Error(`${target.constructor.name}.${propertyKey.toString()} should have one argument!`);
        }
        if (paramTypes.length > 1) {
            throw new Error(`${target.constructor.name}.${propertyKey.toString()} should have only one argument!`);
        }
        if (!(paramTypes[0].prototype instanceof core_1.Event)) {
            throw new Error(`${target.constructor.name}.${propertyKey.toString()} should have an event as argument!`);
        }
        (0, reflect_1.reflect)(target, propertyKey).registerEventHandler(paramTypes[0].prototype, mode);
    };
}
//# sourceMappingURL=event-handler.js.map