"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateContextMiddleware = CreateContextMiddleware;
const core_1 = require("@my-devkit/core");
const context_1 = require("../../context");
function CreateContextMiddleware(bus) {
    return (request, _response, next) => __awaiter(this, void 0, void 0, function* () {
        context_1.Context.create(bus);
        context_1.Context.correlationId = request.header('X-Correlation-ID') || (0, core_1.guid)();
        core_1.Logger.info(`${request.method} ${request.path}: context created`);
        next();
    });
}
//# sourceMappingURL=create-context-middleware.js.map