"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorMiddleWare = ErrorMiddleWare;
const core_1 = require("@my-devkit/core");
const context_1 = require("../../context");
const server_1 = require("../server");
function ErrorMiddleWare() {
    return (error, _request, response) => __awaiter(this, void 0, void 0, function* () {
        if (!(error instanceof Error)) {
            error = new Error(error);
        }
        let status = server_1.Server.statusCodes.INTERNAL_SERVER_ERROR;
        if (error.name === 'UnauthorizedError') {
            status = server_1.Server.statusCodes.UNAUTHORIZED;
        }
        else if (error.name === 'BadRequestError') {
            status = server_1.Server.statusCodes.BAD_REQUEST;
        }
        else if (error.name === 'DomainError') {
            status = server_1.Server.statusCodes.BAD_REQUEST;
        }
        else if (error.name === 'ForbiddenError') {
            status = server_1.Server.statusCodes.FORBIDDEN;
        }
        else if (error.name === 'NotImplemented') {
            status = server_1.Server.statusCodes.NOT_IMPLEMENTED;
        }
        else if (error.name === 'NotFoundError') {
            status = server_1.Server.statusCodes.NOT_FOUND;
        }
        core_1.Logger.error(`${error.name}: ${error.message}`);
        context_1.Context.destroy();
        response.status(status).send({ message: error.message });
    });
}
//# sourceMappingURL=error-middleware.js.map