"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HeadersMiddleWare = HeadersMiddleWare;
const context_1 = require("../../context");
function HeadersMiddleWare() {
    return (_request, response, next) => __awaiter(this, void 0, void 0, function* () {
        response.removeHeader('X-Powered-By'); // Remove verbose express
        response.setHeader('Cache-Control', 'no-cache, no-store, must-revalidate'); // HTTP 1.1.
        response.setHeader('Pragma', 'no-cache'); // HTTP 1.0.
        response.setHeader('Expires', '0'); // Proxies.
        response.setHeader('Content-Type', 'application/json'); // default response type
        response.setHeader('Access-Control-Allow-Credentials', 'true');
        response.setHeader('X-Correlation-ID', context_1.Context.correlationId);
        next();
    });
}
//# sourceMappingURL=headers-middleware.js.map