import { deserialize } from '@my-devkit/core';

import { reflect, RequestArgumentInjector } from '../../reflect';
import { Server } from '../../server';

export function Body(): ParameterDecorator {
    return (target, propertyKey, parameterIndex) => {
        const methodArguments = reflect(target, propertyKey).getParameters();
        if (!methodArguments.hasOwnProperty(parameterIndex)) {
            throw new Error(`Body: can't find argument ${parameterIndex} on ${target.constructor.name}.${propertyKey.toString()}`);
        }

        const injector: RequestArgumentInjector = (req: Server.Request) => deserialize(req.body, methodArguments[parameterIndex]);

        reflect(target, propertyKey).registerControllerRouteArgumentInjector(injector, parameterIndex);
    }
}
