import { expect } from 'chai';

import { reflect } from '../../reflect';
import { Controller } from './controller';

describe('Given a Controller decorator', () => {

    @Controller('test')
    class TestClass {
    }

    describe('When decorator is called', () => {
        it('Then we should retrieve information via reflect', async () => {
            const config = reflect(TestClass).getControllerConfiguration();

            expect(config.basePath).equals('test');
        });
    });
});
