import { guid } from '@my-devkit/core';
import { expect } from 'chai';

import { Get } from '.';
import { reflect } from '../../reflect';
import { RequestMethod } from '../../request-method.enum';
import { Controller } from './controller';

describe('Given a Get decorator', () => {

    @Controller('test')
    class TestClass {
        public test = guid();

        @Get('create')
        public get(): string {
            return `create`;
        }
    }

    describe('When decorator is called', () => {
        it('Then we should retrieve information via reflect', async () => {
            const config = reflect(TestClass).getControllerConfiguration();

            expect(config.routes.length).equal(1, 'Wrong route count detected');

            expect(config.routes[0].path).equal('create');
            expect(config.routes[0].methodName).equal('get');
            expect(config.routes[0].requestMethod).equal(RequestMethod.GET);
        });
    });
});
