import { guid, Logger } from '@my-devkit/core';

import { Bus } from '../../bus';
import { Context } from '../../context';
import { Server } from '../server';

export function CreateContextMiddleware(bus: Bus): Server.RequestHandler {
    return async (request: Server.Request, _response: Server.Response, next: Server.NextFunction): Promise<void> => {
        Context.create(bus);
        Context.correlationId = request.header('X-Correlation-ID') || guid();

        Logger.info(`${request.method} ${request.path}: context created`);

        next();
    };
}
