import { Context } from '../../context';
import { Server } from '../server';

export function HeadersMiddleWare(): Server.RequestHandler {
    return async (_request: Server.Request, response: Server.Response, next: Server.NextFunction): Promise<void> => {
        response.removeHeader('X-Powered-By'); // Remove verbose express
        response.setHeader('Cache-Control', 'no-cache, no-store, must-revalidate'); // HTTP 1.1.
        response.setHeader('Pragma', 'no-cache'); // HTTP 1.0.
        response.setHeader('Expires', '0'); // Proxies.
        response.setHeader('Content-Type', 'application/json'); // default response type
        response.setHeader('Access-Control-Allow-Credentials', 'true');
        response.setHeader('X-Correlation-ID', Context.correlationId);

        next();
    };
}
